#include <Event.h>
#include <Timer.h>
#define BUTTON_PIN  5
#define LED_PIN     6
#define VIN 5.0
#include <math.h>
#define NODE_SIZE 5
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,16,2);
int n=0;
int s=0;
boolean flag=false;
boolean pulse;
float temp;
float vout;
boolean buttonWasUp = true;  // была ли кнопка отпущена?
boolean ledEnabled = false;  // включен ли свет?
Timer  t;
Timer t1;
int timeeleps=10;
boolean checkFinger = false;

struct Node{
    float T;
    float Vout;
    Node() {}
    Node(float t, float v) : T(t),Vout(v){}
};

Node nodes[NODE_SIZE];

void initVT() {
    nodes[0] = Node(25.f,2.42f);
    nodes[1] = Node(30.f,3.38814f);
    nodes[2] = Node(35.f,4.03007f);
    nodes[3] = Node(40.f,4.47069f);
    nodes[4] = Node(45.f,4.78299f);
}
float mapTfromVout(float v){
    int index(0);

    for (int var = 0; var < NODE_SIZE; ++var) {
        if(v < nodes[var].Vout)
            break;
        index++;
    }

    float current_t = nodes[index-1].T +
                    (v - nodes[index - 1].Vout) /
                    (nodes[index].Vout - nodes[index-1].Vout) * (nodes[index].T - nodes[index - 1].T);

    return current_t;
}
 
void setup()
{
  initVT();
  pinMode(A3,INPUT);
  pinMode(A0,INPUT);
  pinMode(LED_PIN, OUTPUT);
  pinMode(BUTTON_PIN, INPUT_PULLUP);
  lcd.init();                            // Инициализация lcd             
  lcd.backlight(); 
//  t.every(10000, takeReading); 
  t1.every(1000, funksec);
  
    
}
//void takeReading(){
//  lcd.setCursor(0, 0);
//  
//  s=n*10;
//  lcd.print("s");
//}
void funksec(){
  if(checkFinger ){
    timeeleps--;
    lcd.clear();
    lcd.setCursor(0, 0);
     lcd.print("Pulse: ost ");
     lcd.print(timeeleps);
     lcd.setCursor(0,1);
     lcd.print("Temp.: ");
     lcd.print(temp,1);
  }else if(!buttonWasUp){
     lcd.setCursor(0, 0);
     lcd.print("Pulse: palcheg ");
     lcd.setCursor(0,1);
     lcd.print("Temp.: ");
     lcd.print(temp,1);
  }
  
  if(timeeleps==0){
    lcd.clear();
      t1.stop(0);
       lcd.setCursor(0, 0);
       lcd.print("Pulse: ");
       lcd.print(n*10);
       lcd.setCursor(0,1);
       lcd.print("Temp.: ");
       lcd.print(temp,1);
       checkFinger = false;
  }
}
void loop()
{
  
  t1.update();
  
  vout=analogRead(A0)*5.0/ 1024.0;
  temp= mapTfromVout(vout);
  boolean buttonClicked = digitalRead(BUTTON_PIN);
  if(buttonWasUp && !buttonClicked){
    delay(10); 
    buttonClicked = digitalRead(BUTTON_PIN);
    
    if (!buttonClicked) {  
      ledEnabled = !ledEnabled;
      digitalWrite(LED_PIN, ledEnabled);
      buttonWasUp = buttonClicked;
      timeeleps=10;
      n = 0;
      checkFinger = false;
      t1.stop(0);
      t1.every(1000, funksec);
      lcd.clear();
     }
     
  }else if(!buttonWasUp && !buttonClicked){
    delay(10);
    buttonClicked = digitalRead(BUTTON_PIN);
    
    if (!buttonClicked) {  
      ledEnabled = !ledEnabled;
      digitalWrite(LED_PIN, ledEnabled);
       buttonWasUp = !buttonClicked;
       n = 0;
       s=0;
       timeeleps=10;
       t1.stop(0);
       lcd.clear();
     }
     
  }
  
  if(ledEnabled && !buttonWasUp){
//    time=millis();
    pulse=digitalRead(A3);
    
         
    if(pulse==HIGH && flag==false){
       n = n + 1;
       checkFinger = true;
       flag=true;
     }else if(pulse==LOW){
       flag=false;
     }
//     lcd.setCursor(0, 0);
//     lcd.print("Pulse: ");
//     lcd.print(analogRead(A3)*5.0/1023.0);
//     lcd.setCursor(0,1);
//     lcd.print("Temp.: ");
//     lcd.print(temp,1);
  }
}


